
// Demo: struct item alignment and padding
// Bytes: (integers=FF, padding=00)
// Try (on 64bit system):
//   gcc        thisfile.c
//   gcc -m32   thisfile.c
//   gcc -DPACK thisfile.c

#include <stdio.h>

#ifdef PACK
#  pragma pack(1)       // use for extra compact structs (slow)
#endif
struct Test {
    char c1;
    short s;
    char c2;
    int i;
    char c3;
    long long l;
    char c4;
} t = { '1', -1, '2', -1, '3', -1LL, '4' };

int main(void) {
    int i;
    const size_t sz = sizeof(struct Test);
    unsigned char *p = (unsigned char *)&t;
    printf("sizeof = %zd\n", sz);
    printf("contents = {\n  ");
    for(i=0;i<sz;++i)
        printf("%02x,", p[i]);  // bytes
    printf("\n/*");
    for(i=0;i<sz;++i)
        printf("%2d ", i);      // print index for readability
    printf("*/\n}\n");
    return 0;
}

